.586p
.model flat,stdcall
option casemap:none

include calc32.inc

.code
start:
	invoke	GetModuleHandle, NULL
	mov	       hInstance, eax
	invoke	DialogBoxParam, hInstance, IDD_MAIN, 0, ADDR DlgProc, 0
	invoke	ExitProcess, eax
; -----------------------------------------------------------------------
DlgProc PROC hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
        
        mov eax,uMsg
	.if eax == WM_INITDIALOG
		invoke LoadIcon,hInstance,ID_ICON
		invoke SendMessage, hWnd, WM_SETICON, 1, eax
		invoke SetWindowText,hWnd,addr caption
		invoke CheckRadioButton,hWnd,IDC_XOR, IDC_ROR, IDC_XOR
		
	.elseif eax == WM_COMMAND
	       mov eax,wParam
	       mov ebx,eax
	       shr ebx,16
		.if ax == BTN_ABOUT
			invoke MessageBox,hWnd,addr AboutTxt,addr caption,MB_ICONINFORMATION
		      
		.elseif ( ax == IDC_OP1 || ax == IDC_OP2 ) && bx == EN_CHANGE
			
			invoke GetDlgItemText,hWnd,IDC_OP1,addr szOperand1,sizeof szOperand1
			invoke GetDlgItemText,hWnd,IDC_OP2,addr szOperand2,sizeof szOperand2
			
			invoke HexToDw,addr szOperand1
			mov ebx,eax
			invoke HexToDw,addr szOperand2
			mov edx,eax
						
			mov ecx,n ; number of operators
			mov esi,IDC_XOR
		_l1:
			push ecx
			push edx
			invoke GetDlgItem,hWnd,esi
			invoke SendMessage,eax,BM_GETCHECK,0,0
			pop edx
			pop ecx
			or eax,eax
			jnz _esc
			inc esi
			loop _l1
		_esc:
			push ecx
			push edx
			invoke GetDlgItemText,hWnd,esi,addr szStatus, sizeof szStatus
			invoke SetDlgItemText,hWnd,IDC_STATUS,addr szStatus
			pop edx
			pop ecx	
			
			mov eax,esi
			sub eax,IDC_XOR
			jb _Error1
			cmp eax,n
			ja _Error1
			jmp [table+eax*4]
			table dd case_1,case_2,case_3,case_4,case_5,case_6,case_7,case_8,case_9
		case_1:
			xor ebx,edx
			jmp _endswitch
		case_2:
			and ebx,edx
			jmp _endswitch
		case_3:
			or ebx,edx
			jmp _endswitch
		case_4:
			add ebx,edx
			jmp _endswitch
		case_5:
			sub ebx,edx
			jmp _endswitch
		case_6:
			cmp edx,0FFh
			ja _Error1
			mov ecx,edx
			shl ebx,cl
			jmp _endswitch
		case_7:
			cmp edx,0FFh
			ja _Error1
			mov ecx,edx
			shr ebx,cl
			jmp _endswitch
		case_8:			
			cmp edx,0FFh
			ja _Error1
			mov ecx,edx
			rol ebx,cl
			jmp _endswitch
		case_9:
			cmp edx,0FFh
			ja _Error1
			mov ecx,edx
			ror ebx,cl
			jmp _endswitch
		_Error1:
			invoke SetDlgItemText,hWnd,IDC_RESULT1,chr$("Incorrect operands")
			xor eax,eax
			ret
		_endswitch:
			
		invoke wsprintf,addr szHexResult,chr$("%08X"),ebx
		invoke SetDlgItemText,hWnd,IDC_RESULT1,addr szHexResult
                    
		.endif
		
	.elseif eax == WM_CLOSE
		invoke EndDialog,hWnd,0
	.endif

	xor	eax,eax
	ret
DlgProc	endp

; by lingo (drizz stdlib)
HexToDw PROC pString:DWORD
	mov ecx,pString
	xor eax,eax
	mov [ebp+8],ebx ;save ebx register
	xor ebx,ebx
@@:	
	movzx edx,byte ptr[ecx]
	shl eax,4
	and ebx,0Fh
	add eax,ebx
	cmp edx,40h
	sbb ebx,ebx
	sub edx,37h
	and ebx,7
	inc ecx
	add ebx,edx
	jns @B
	mov ebx,[ebp+8]
	ret 1*4
HexToDw ENDP

end start
